namespace co_context::detail {

    struct [[nodiscard]] task_info {
        std::coroutine_handle<> handle;

        int32_t result;

        [[nodiscard]]
        uint64_t as_user_data() const noexcept {
            return static_cast<uint64_t>(reinterpret_cast<uintptr_t>(this));
        }
    };
}